
from threading import Lock, Event

class Channel(object):

    def __init__(self):
        self._writelock = Lock()
        self._readlock = Lock()
        self._new_data = Event()
        self._recv_data = Event()
        self._data = None

    def put(self, msg):
        with self._writelock:
            self._data = msg
            self._new_data.set()
            self._recv_data.wait()
            self._recv_data.clear()

    def get(self):
        with self._readlock:
            self._new_data.wait()
            msg = self._data
            self._data = None
            self._new_data.clear()
            self._recv_data.set()
        return msg
            
        
if __name__ == "__main__":

    from threading import Thread
    from sys import stdout
    stdout_lock = Lock()
    channel = Channel()

    def thread2():
        for i in range(1000):

            msg = channel.get()

            with stdout_lock:
                print "Thread 2 received '%s'\n" % msg,
                stdout.flush()

    def thread1():
        for i in range(1000):

            with stdout_lock:
                print "Thread 1 preparing to send 'message %d'\n" % i,
                stdout.flush()

            msg = channel.put(("message %d" % i,))

            with stdout_lock:
                print "Thread 1 finished sending 'message %d'\n" % i,
                stdout.flush()
            
    t2 = Thread(target=thread2)
    t2.start()
    thread1()
    t2.join()


    





        
    
        
